﻿using Com.Asreader.P3xu;
using Com.Asreader.P3xu.Rfid.Type;
using Com.Asreader.P3xu.Device.Type;

namespace AsReaderP3xUAndroidDemo.Platforms.Android
{
	public class AsReaderP3xUCallback
    {
        public delegate void OnStateChangedCallback(AsReaderP3xU p0, AsReaderP3xUConnectionState p1);
        public OnStateChangedCallback OnStateChanged;

        public delegate void OnReadTagCallback(AsReaderP3xU p0, AsReaderP3xUActionState p1, string p2, float p3);
        public OnReadTagCallback OnReadTag;

        public delegate bool OnKeyEventCallback(AsReaderP3xU p0, AsReaderP3xUKeyType p1, AsReaderP3xUKeyState p2);
        public OnKeyEventCallback OnKeyEvent;

        public delegate void OnActionChangedCallback(AsReaderP3xU p0, AsReaderP3xUActionState p1);
        public OnActionChangedCallback OnActionChanged;

        public delegate void OnAccessResultCallback(AsReaderP3xU p0, AsReaderP3xUResultCode p1, AsReaderP3xUActionState p2, string p3, string p4);
        public OnAccessResultCallback OnAccessResult;

        public delegate void OnReceivedDidBecomeActiveCallback(bool status);
        public OnReceivedDidBecomeActiveCallback OnReceivedDidBecomeActive;

        static AsReaderP3xUCallback uniqueInstance;

        static readonly object locker = new object();

        public static AsReaderP3xUCallback sharedInstance()
        {
            if (uniqueInstance == null)
            {
                lock (locker)
                {
                    if (uniqueInstance == null)
                    {
                        uniqueInstance = new AsReaderP3xUCallback();
                    }
                }
            }
            return uniqueInstance;
        }
        public AsReaderP3xUCallback()
        {
        }
    }
}

